#include <stdio.h>
#include <stdlib.h>
#include "list.h"

#define MAX_LINE 1024

typedef struct anode
{
  char *line;
  struct anode *next;
}
node;

node *head, *current;

void
build_list (FILE * input)
{
  char *blah;
  blah = (char *) malloc (sizeof (char) * MAX_LINE);
  current = head;
  while (fgets (blah, 1024, input))
    {
      node *x;
      x = malloc (sizeof (node));
      x->next = NULL;
      x->line = (char *) malloc (sizeof (char) * strlen (blah));
      memcpy (x->line, blah, sizeof (char) * strlen (blah));
      if (current != NULL)
	current->next = x;
      else
	head = x;
      current = x;
    }
  current = head;
  return;
}

int
get_out_width ()
{
  int best = 0;
  node *x;
  x = head;
  while (x != NULL)
    {
      if (strlen (x->line) > best)
	best = strlen (x->line);
      x = x->next;
    }
  return best;
}

int
get_out_height ()
{
  int height = 0;
  node *x;
  x = head;
  while (x != NULL)
    {
      height++;
      x = x->next;
    }

  return height;
}

int
more_lines ()
{
  if (current == NULL)
    return 0;
  return 1;
}

char *
show_line ()
{
  return current->line;
}

void
advance_line ()
{
  current = current->next;
  return;
}

void
empty_list ()
{
  node *x;
  x = head;
  while (head != NULL)
    {
      x = head->next;
      free (head);
      head = x;
    }
  return;
}
